---
title: 'HTMLFormElement: submit event'
slug: Web/API/HTMLFormElement/submit_event
tags:
  - API
  - Event
  - Forms
  - HTML DOM
  - HTMLFormElement
  - Reference
  - submit
---
<div>{{APIRef}}</div>

<p>The <strong><code>submit</code></strong> event fires when a {{HtmlElement("form")}} is submitted.</p>

<table class="properties">
 <tbody>
  <tr>
   <th>Bubbles</th>
   <td>Yes (although specified as a simple event that doesn't bubble)</td>
  </tr>
  <tr>
   <th>Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th>Interface</th>
   <td>{{DOMxRef("SubmitEvent")}}</td>
  </tr>
  <tr>
   <th>Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.onsubmit")}}</td>
  </tr>
 </tbody>
</table>

<p>Note that the <code>submit</code> event fires on the <code>&lt;form&gt;</code> element itself, and not on any {{HtmlElement("button")}} or {{HtmlElement('input/submit', '&lt;input type="submit"&gt;')}} inside it. However, the {{domxref("SubmitEvent")}} which is sent to indicate the form's submit action has been triggered includes a {{domxref("SubmitEvent.submitter", "submitter")}} property, which is the button that was invoked to trigger the submit request.</p>

<p>The <code>submit</code> event fires when the user clicks a submit button ({{HtmlElement("button")}} or {{HtmlElement('input/submit', '&lt;input type="submit"&gt;')}}) or presses <kbd>Enter</kbd> while editing a field (e.g. {{HtmlElement('input/text', '&lt;input type="text"&gt;')}}) in a form. The event is not sent to the form when calling the {{domxref("HTMLFormElement.submit()", "form.submit()")}} method directly.</p>

<div class="notecard note">
<p><strong>Note:</strong> Trying to submit a form that does not pass <a href="/en-US/docs/Learn/HTML/Forms/Form_validation">validation</a> triggers an {{domxref("HTMLInputElement/invalid_event", "invalid")}} event. In this case, the validation prevents form submission, and thus there is no <code>submit</code> event.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>This example uses {{domxref("EventTarget.addEventListener()")}} to listen for form submit, and logs the current {{domxref("Event.timeStamp")}} whenever that occurs, then prevents the default action of submitting the form.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;form id="form"&gt;
  &lt;label&gt;Test field: &lt;input type="text"&gt;&lt;/label&gt;
  &lt;br&gt;&lt;br&gt;
  &lt;button type="submit"&gt;Submit form&lt;/button&gt;
&lt;/form&gt;
&lt;p id="log"&gt;&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">function logSubmit(event) {
  log.textContent = `Form Submitted! Time stamp: ${event.timeStamp}`;
  event.preventDefault();
}

const form = document.getElementById('form');
const log = document.getElementById('log');
form.addEventListener('submit', logSubmit);</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "indices.html#event-submit", "submit")}}</td>
   <td>{{Spec2("UI Events")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.2", "fullindex.html#eventdef-global-submit", "submit")}}</td>
   <td>{{Spec2("HTML5.2")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "fullindex.html#eventdef-global-submit", "submit")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "index.html#events-0", "submit")}}</td>
   <td>{{Spec2("HTML5 W3C")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLFormElement.submit_event")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>HTML {{HtmlElement("form")}} element</li>
 <li>Related event: {{domxref("HTMLInputElement/invalid_event", "invalid")}}</li>
</ul>
